/*
   This file defines Box3 objects.

   A Box3 object holds the data that describes a real box.
   The data is private, so the data can only be manipulated
   through methods that belong to the object.

   A Box3 object knows how to compute its volume and its
   "length plus girth".
*/

class Box3
{
   // three (private) instance variables
   private double length;
   private double width;
   private double height;

   // define a constructor
   public Box3(double newLength, double newWidth, double newHeight)
   {
      length = newLength;
      width = newWidth;
      height = newHeight;
   }//Box3 constructor


   // since the data is now private, we should
   // define three "get methods", one for each
   // data field of the class
   public double getLength()
   {
      return length;
   }

   public double getWidth()
   {
      return width;
   }

   public double getHeight()
   {
      return height;
   }

   // define a method for computing the volume of the box
   public double volume()
   {
      return height*width*length;
   }

   // define a method to compute "length plus girth"
   public double lengthPlusGirth()
   {
       // the "length" should be the largest
       // dimension of the box
       if (width > length)
       {
          // if width is larger than length
          // then swap the two values
          // (notice that we are manipulating
          // the data in this Box3 object)
          double temp = length;
          length = width;
          width = temp;
       }
       if (height > length)
       {
          // if height is larger than length
          // then swap the two values
          double temp = length;
          length = height;
          height = temp;
       }
       return length+2*width+2*height;
   }//lengthPlusGirth()

}//Box3