/*
   This program reads in the dimensions of a box and then stores
   the data in a Box data structure.

   The program then "does something" with the box data structure
   (for example, it could store it in a file or a database). This
   program prints out the contents of the data structure and then
   computes the volume and "length plus girth" of the box.

   Notice how, once the data is placed in a Box data structure, it
   can be passed around (e.g., to a method) as one unit instead of as
   three numbers.
*/
import java.util.Scanner;

public class UseBox1
{
   public static void main(String[] args)
   {
      Scanner sc = new Scanner(System.in);

      Box1 box;          // declare a variable of type Box1
      box = new Box1();  // create a Box1 object and name it box

      // get data from the keyboard operator
      System.out.println("Please enter the dimensions of the box.");
      System.out.print("Please enter the height: ");
      double height = sc.nextDouble();
      System.out.print("Please enter the width: ");
      double width = sc.nextDouble();
      System.out.print("Please enter the length: ");
      double length = sc.nextDouble();

      // store the data in the Box object
      box.height = height;
      box.width = width;
      box.length = length;

      // make use of the data in the Box object
      System.out.println("The dimensions of the box are");
      System.out.println("height is " + box.height + ",");
      System.out.println("width is "  + box.width + ",");
      System.out.println("length is " + box.length + ".");
      System.out.println("The volume of the box is " + volume(box) + ".");
      System.out.println("The length plus girth of the box is " + lengthPlusGirth(box) + ".");
   }//main()



   static double volume(Box1 box)
   {
      return (box.width * box.length * box.height);
   }


   static double lengthPlusGirth(Box1 box)
   {
       // the "length" should be the largest
       // dimension of the box
       if (box.width > box.length)
       {
          // if width is larger than length
          // then swap the two values
          // (notice that we are manipulating
          // the data in the Box1 object)
          double temp = box.length;
          box.length = box.width;
          box.width = temp;
       }
       if (box.height > box.length)
       {
          // if height is larger than length
          // then swap the two values
          double temp = box.length;
          box.length = box.height;
          box.height = temp;
       }
       return box.length+2*box.width+2*box.height;
   }//lengthPlusGirth()

}//UseBox