/*
   This program reads in the dimensions of a box and then stores
   the data in a Box2 data structure.

   This program makes use of the fact that Box2 objects have a
   constructor for initializing the fields of the data structure
   with any given data (instead of initializing the fields with
   the Java defined default values).
*/
import java.util.Scanner;

public class UseBox2
{
   public static void main(String[] args)
   {
      Scanner sc = new Scanner(System.in);

      Box2 box;  // declare a variable of type Box2

      // get data from the keyboard operator
      System.out.println("Please enter the dimensions of the box.");
      System.out.print("Please enter the height: ");
      double height = sc.nextDouble();
      System.out.print("Please enter the width: ");
      double width = sc.nextDouble();
      System.out.print("Please enter the length: ");
      double length = sc.nextDouble();

      // create a Box2 object with the appropriate
      // dimensions (using a constructor)  and name it box
      box = new Box2(height, width, length);

      // make use of the data in the Box object
      System.out.println("The dimensions of the box are");
      System.out.println("height is " + box.height + ",");
      System.out.println("width is "  + box.width + ",");
      System.out.println("length is " + box.length + ".");
      System.out.println("The volume of the box is " + volume(box) + ".");
      System.out.println("The length plus girth of the box is " + lengthPlusGirth(box) + ".");
   }//main()


   static double volume(Box2 box)
   {
      return (box.width * box.length * box.height);
   }


   static double lengthPlusGirth(Box2 box)
   {
       // the "length" should be the largest
       // dimension of the box
       if (box.width > box.length)
       {
          // if width is larger than length
          // then swap the two values
          // (notice that we are manipulating
          // the data in the Box2 object)
          double temp = box.length;
          box.length = box.width;
          box.width = temp;
       }
       if (box.height > box.length)
       {
          // if height is larger than length
          // then swap the two values
          double temp = box.length;
          box.length = box.height;
          box.height = temp;
       }
       return box.length+2*box.width+2*box.height;
   }//lengthPlusGirth()

}//UseBox2