/*
   This program reads in the dimensions of a box and then constructs
   a Box3 object that encapsulates the data for the box.

   Since the data fields of an object are private, this program uses
   "accessor methods" (i.e., get methods) to retrive data from the object.

   This program makes use of the fact that Box3 objects can compute their
   own volume and "length plus girth".
*/
import java.util.Scanner;

public class UseBox3
{
   public static void main(String[] args)
   {
      Scanner sc = new Scanner(System.in);

      Box3 box;  // declare a variable of type Box3

      // get data from the keyboard operator
      System.out.println("Please enter the dimensions of the box.");
      System.out.print("Please enter the height: ");
      double height = sc.nextDouble();
      System.out.print("Please enter the width: ");
      double width = sc.nextDouble();
      System.out.print("Please enter the length: ");
      double length = sc.nextDouble();

      // create a Box3 object with the appropriate
      // dimensions (using a constructor)  and name it box
      box = new Box3(height, width, length);

      // make use of the data in the Box object
      System.out.println("The dimensions of the box are");
      System.out.println("height is " + box.getHeight() + ",");
      System.out.println("width is " + box.getWidth() + ",");
      System.out.println("length is " + box.getLength() + ".");
      System.out.println("The volume of the box is " + box.volume() + ".");
      System.out.println("The length plus girth of the box is " + box.lengthPlusGirth() + ".");
   }//main()
}//UseBox3