/*
   This program reads in the dimensions of a box and then constructs
   a Box4 object that encapsulates the data for the box.

   This program makes use of the fact that a Box4 object knows to
   label its largest dimension as its length.

   This program makes use of the fact that a Box4 object knows how to
   provide a printable description of itself.

   Finally, notice that as the length of the Box classes grew longer,
   the length of the UseBox programs grew shorter. Complexity was
   moved from the programs into the objects that the programs used.
*/
import java.util.Scanner;

public class UseBox4
{
   public static void main(String[] args)
   {
      Scanner sc = new Scanner(System.in);

      Box4 box;  // declare a variable of type Box4

      // get data from the keyboard operator
      System.out.println("Please enter the dimensions of the box.");
      System.out.print("Please enter the first dimension: ");
      double dim1 = sc.nextDouble();
      System.out.print("Please enter the second dimension: ");
      double dim2 = sc.nextDouble();
      System.out.print("Please enter the third dimension: ");
      double dim3 = sc.nextDouble();

      // create a Box4 object with the appropriate
      // dimensions (using a constructor)  and name it box
      box = new Box4(dim1, dim2, dim3);

      // make use of the data in the Box object
      System.out.println(box);
      System.out.println("The volume of the box is " + box.volume() + ".");
      System.out.println("The length plus girth of the box is " + box.lengthPlusGirth() + ".");
      System.out.println();
   }//main()
}//UseBox4