/**
   This simple program demonstrates some of the differences
   between primitive variables and object variables.

   The most important "primitive" variable types are
      int
      double
      boolean
      char

   Remember that "object variables" are often called "reference variables".

   Be sure to try this sequence of commands in DrJava's "Interaction Pane".
*/
import java.awt.Dimension;
import java.awt.Color;

public class PrimitiveVsObjectVariables
{
   public static void main( String[] args )
   {
      int i;         // a primitive variable of type "int"
      Dimension d;   // an object variable of type "Dimension"

      System.out.println(i);  // what is the "initial value"?
      System.out.println(d);  // (doesn't work in the compiler window)

      i = 7;
      d = new Dimension(4, 5);

      System.out.println(i);  // what are the current values?
      System.out.println(d);

      int j;       // another primitive variable of type int
      Dimension c; // another object variable of type Dimension

      // The next two statements act very differently!!
      j = i;  // assigning primitive variables (copy values)
      c = d;  // assigning object variables    (copy references)

      System.out.println(j);  // what are the current values of the new variables?
      System.out.println(c);

      // Change the value in the j and c variables
      j = 107;
      c.setSize(104, 105);

      // Check the values in the i and d variables
      System.out.println(i);
      System.out.println(d);

      // Here are some things that you cannot do.
      // (Read each compiler error message carefully.)
      //i = d;
      //i = 3.5;
      //c = new Color(1, 2, 3);
      //d.setSize(25);
   }//main()

}