/**
   This is a very simple example of a class that
   defines objects with "state", which is a fancy
   way of saying that each object of this class
   remembers a simple piece of data (its "state").

   Here is a sample interaction.

   First, create two object variables.

   > SimpleClassWithState obj1
   > SimpleClassWithState obj2

   Next, create two objects.

   > obj1 = new SimpleClassWithState()
   > obj2 = new SimpleClassWithState()

   Check their "state".

   > obj1.reportState()
   > obj2.reportState()

   Have each object modify its own state.

   > obj1.increaseState()
   > obj1.increaseState()
   > obj1.increaseState()
   > obj1.increaseState()
   > obj2.increaseState()
   > obj2.increaseState()

   Check their state again.

   > obj1.reportState()
   > obj2.reportState()
*/

public class SimpleClassWithState
{
   ////////// state //////////

   int x = 0;  // this piece of data is the "state" of an object


   ////////// methods //////////

   public int reportState()
   {
      return this.x;
   }

   public void increaseState()
   {
      this.x = this.x + 1;
   }

}