/**
   This is an example of a class that defines objects
   with "state" and which also defines "class state".
   In other words, this clas has both instance variables
   and static variables.

   Here is a sample interaction.

   First, check, then modify, then check again, the class state.

   > SimpleClassWithStaticAndInstanceState.reportClassState()
   > SimpleClassWithStaticAndInstanceState.increaseClassState()
   > SimpleClassWithStaticAndInstanceState.reportClassState()

   Now, create two reference variables.

   > SimpleClassWithStaticAndInstanceState obj1
   > SimpleClassWithStaticAndInstanceState obj2

   Next, create two objects.

   > obj1 = new SimpleClassWithStaticAndInstanceState()
   > obj2 = new SimpleClassWithStaticAndInstanceState()

   Check their "state".

   > obj1.reportState()
   > obj2.reportState()

   Have each object modify its own state and the clas state.

   > obj1.increaseState()
   > obj1.increaseState()
   > obj1.increaseState()
   > obj1.increaseClassState()
   > obj1.increaseClassState()
   > obj2.increaseState()
   > obj2.increaseState()
   > obj2.increaseClassState()


   Check all the states again.

   > obj1.reportState()
   > obj2.reportState()
   > SimpleClassWithStaticAndInstanceState.reportClassState()
   > obj1.reportClassState()  // this is redundant with the previous line
   > obj2.reportClassState()  // this is redundant with the previous two lines
*/

public class SimpleClassWithStaticAndInstanceState
{
   ////////// state //////////

   int x = 0;        // this piece of data is the "state" of an object

   static int s = 0; // this piece of data is the static state for this class


   ////////// methods //////////

   /// instance methods
   public int reportState()
   {
      return this.x;
   }

   public void increaseState()
   {
      this.x = this.x + 1;
   }

   /// static methods
   public static int reportClassState()
   {
      return s;  // notice that there is no "this" keyword
   }

   public static void increaseClassState()
   {
      s = s + 1;   // notice that there is no "this" keyword
   }
}