/**
   The following code defines some unusually structured matrices.
   Draw memory maps for each of the two dimensional arrays
   constructed below.

   You can also try executing thses commands in the DrJava
   interaction pane.
*/
import java.util.Arrays; // needed for its deepToString() method

public class ArrayMemoryModel
{
  public static void main( String[] args )
  {
    // Draw memory models for the two dimensional
    // matrices defined by the following literals.
    int[][] matrix1 = { {1, 2, 3}, {4, 5, 6} };
    int[][] matrix2 = { {1, 2}, {3, 4, 5}, {6, 7, 8, 9} };

    System.out.println( matrix2 );                     // prints out a "reference"
    System.out.println( Arrays.toString(matrix2) );    // prints an "array of references"
    System.out.println( Arrays.deepToString(matrix1) );// prints out what we want
    System.out.println( Arrays.deepToString(matrix2) );

    // Declare, but don't initialize, two more matrix reference variables.
    int[][] matrix3;
    int[][] matrix4;

    // Build, "by hand", a two dimensional matrix for matrix3.
    // Draw a memory model of the resulting (one dimensional) arrays.
    matrix3 = new int[5][];  // construct the one dimensional "array of rows"
    matrix3[0] = matrix1[0]; // now add some (one dimensional) rows to the matrix.
    matrix3[1] = matrix2[0];
    matrix3[2] = new int[10]; // this creates a new row
    matrix3[3] = matrix2[2];
    matrix3[4] = matrix1[1];

    System.out.println( Arrays.deepToString(matrix3) );

    // Build, "by hand", a two dimensional matrix for matrix4.
    // Draw a memory model of the resulting arrays.
    matrix4 = new int[4][];
    matrix4[0] = matrix1[0];
    matrix4[1] = matrix1[0];
    matrix4[2] = matrix1[0];
    matrix4[3] = matrix1[0];

    System.out.println( Arrays.deepToString(matrix4) );
    matrix1[0][1] = 99999;  // Note that we are using matrix1 here
    System.out.println( Arrays.deepToString(matrix4) );
  }//main()
}