/*
    Demonstration of polymorphism.

    This file contains four private classes,
    an Animal base class and three classes
    that extend Animal.

    There is one public class in this file
    and it contains a main() method for testing
    the polymorphism of the Animal classes.
*/

class Animal
{
  private int legs = 4;

  public void talk()
  {
    System.out.println("Animals can't talk.");
  }
}


class Pig extends Animal
{
  public void talk()
  {
    System.out.println("Oink.");
  }
}


class Cow extends Animal
{
  public void talk()
  {
    System.out.println("Moo.");
  }

  // add a method to class Cow that is not in class Animal
  public void talk2()
  {
    System.out.println("Moo, moo.");
  }
}


class Dog extends Animal
{
  public void talk()
  {
    System.out.println("Woof.");
  }
}



public class Animals
{
   public static void main(String[] args)
   {
      // create an array of Animal references
      Animal[] barnYard = new Animal[3];

      // fill the array with references to objects that are subclasses of Animal
      barnYard[0] = new Pig();
      barnYard[1] = new Cow();
      barnYard[2] = new Dog();

      // now loop through the array and access the talk() methods polymorphically
      for (int i = 0; i < barnYard.length; i++)
      {
         barnYard[i].talk();  // Which talk() method is called???
      }

      // try making the cow moo twice
//    barnYard[1].talk2();  // this doesn't work
      // use a cast (since barnYard[1] really does point to a Cow object)
      ((Cow)barnYard[1]).talk2();

      // try making the pig moo twice
      ((Cow)barnYard[0]).talk2();  // This compiles but does not run!!

   }//main()
}