/*
   This class defines TemperatureReading2 objects.

   A temperature is stored in degrees Kelvin, but this
   implementation detail is hidden from the user of
   TemperatureReading2 objects by the public interface
   (i.e., the constructors and the set and get methods).
   The public interface uses degrees Celsius and Fahrenheit.
*/

public class TemperatureReading2
{
   // three instance variables
   private double degreesKelvin;
   private double latitude;
   private double longitude;

   // the default constructor
   public TemperatureReading2()
   {
      degreesKelvin = 0;
      latitude = 0;
      longitude = 0;
   }

   // another constructor
   // (Why can't we have TemperatureReading2F and
   // TemperatureReading2C constructors for each
   // temperature scale?)
   public TemperatureReading2(double temperature, char scale,
                              double newLat, double newLong)
   {
      degreesKelvin = 0; //in case scale is neither C nor F
      if (scale == 'C' )
          degreesKelvin = temperature + 273;
      if (scale == 'F')
          degreesKelvin = (temperature - 32)/1.8 + 273;
      // now validate the data so that there cannot be an
      // unrealistic value for the temperature
      if ( degreesKelvin < 0 ) degreesKelvin = 0;

      // now initialize the other two fields
      latitude = newLat;
      longitude = newLong;
   }

   // two get methods (accessor methods) for temperature
   public double getTemperatureC()
   {
       return degreesKelvin - 273;
   }

   public double getTemperatureF()
   {
       return (degreesKelvin - 273)*1.8 + 32;
   }

   // get methods for latitude and longitude
   public double getLatitude()
   {
       return latitude;
   }

   public double getLongitude()
   {
       return longitude;
   }

   // two set methods (mutator methods) for temperature
   public void setTemperatureC(double degreesC)
   {
       if (degreesC >= -273)  //validate the data
           degreesKelvin = degreesC + 273;
       else
           degreesKelvin = 0;
   }

   public void setTemperatureF(double degreesF)
   {
       degreesKelvin = (degreesF - 32)/1.8 + 273;
       //now validate the data
       if ( degreesKelvin < 0 ) degreesKelvin = 0;
   }

   // set methods for latitude and longitude
   public void setLatitude(double newLat)
   {
       latitude = newLat;
   }

   public void setLongitude(double newLong)
   {
       longitude = newLong;
   }

}//TemperatureReading2